#include <cctype>
#include <cstdio>
#include <cstring>
#include <list>

#include "config.hh"
#include "logfun.h"

class strpair { public: string a, b; strpair(const string &aa, const string &bb) : a(aa), b(bb) { } };

class Cfg
{
    list<strpair> sets;
public:
    Cfg(const string &fn);
    const string operator[] (const string &s) const;
};

const string Cfg::operator[] (const string &s) const
{
    list<strpair>::const_iterator i;
    for(i=sets.begin(); i!=sets.end(); ++i)
        if(i->a == s)return i->b;
    return "";
}

Cfg::Cfg(const string &fn)
{
    FILE *fp = fopen(fn.c_str(), "rt");
    if(!fp)return;
    char Buf[8192];
    for(;;)
    {
        if(!fgets(Buf, sizeof Buf, fp))break;
        strtok(Buf, "\n");
        if(!isalpha(Buf[0]))continue;
        string s = Buf;
        unsigned a = s.find(':');
        if(a == s.npos)continue;
        string var = s.substr(0, a);
        while(++a < s.size() && s[a]==' ');
        sets.push_back(strpair(var, s.substr(a)));
    }
    fclose(fp);
}

Config::Config() : p(NULL)
{
}
Config::~Config()
{
    if(p)delete p;
}
void Config::Rehash() const
{
    if(p) { delete p; p=NULL; }
}
const string Config::GetString(const string &name) const
{
    if(!p)p = new Cfg(CONFIG);
    return (*p)[name];
}
const unsigned Config::GetInteger(const string &name) const
{
    if(!p)p = new Cfg(CONFIG);
    const string &s = (*p)[name];
    unsigned a, retval=0;
    for(a=0; a<s.size(); ++a)
        if(isdigit(s[a]))
            retval = retval*10 + (s[a]-'0');
    return retval;
}
const bool Config::GetBool(const string &name) const
{
    if(!p)p = new Cfg(CONFIG);
    string s = (*p)[name];
    unsigned a;
    for(a=0; a<s.size(); ++a)s[a]=toupper(s[a]);
    if(s == "YEP" || s == "YES" || s == "TRUE")return true;
    return false;
}

Config Configuration;
